<template>
	<el-container class="mainBox mainBoxHeaderNoBorder">
		<el-main class="nopadding">
			<div class="searchMain">
				<scSearch ref="scSearch" :searchList="searchList" @fetchSelectData="getSelectData"></scSearch>

				<div class="searchItem searchBtn">
					<el-button :size="size" :icon="searchShow?'el-icon-ArrowUpBold':'el-icon-ArrowDownBold'" @click="searchShowClick">{{searchShow?'收起':'更多'}}</el-button>
					<el-button :size="size" type="primary" icon="el-icon-search" @click="upSearch">查询</el-button>
					<el-button :size="size" type="info" icon="el-icon-RefreshRight" @click="reset">重置</el-button>
				</div>
			</div>
			<scTable ref="table" :apiObj="list.apiObj" :column="list.column" row-key="id" stripe :size="size" @selection-change="selectionChange">
				<el-table-column type="selection" align="center" width="40"></el-table-column>
				<sc-table-column label="序号" align="center" type="index"></sc-table-column>
				<template #logo="scope">
					<el-image class="logoCell" :src="scope.row.logo" preview-teleported :preview-src-list="[scope.row.logo]" fit="contain">
						<template #error>
							<div class="image-slot" style="text-align: center;font-size: 20px;">
								<el-icon><el-icon-Picture /></el-icon>
							</div>
						</template>
					</el-image>
				</template>
				<template #active_status="scope">
					<el-switch :size="size" v-model="scope.row.active_status" @change="changeSwitch($event, scope.row)" :loading="scope.row.$switch_status" :active-value="true" :inactive-value="false"></el-switch>
				</template>
				<el-table-column label="操作" fixed="right" align="center" width="150">
					<template #default="scope">
						<el-dropdown>
							<el-button class="noBorderBtn" icon="el-icon-more" :size="size"></el-button>
							<template #dropdown>
								<el-dropdown-menu>
									<el-dropdown-item @click="table_show(scope.row, 'see')" icon="sc-icon-See">查看详情</el-dropdown-item>
									<el-dropdown-item @click="table_edit(scope.row, 'edit')" icon="sc-icon-Edit">编辑公司</el-dropdown-item>
									<el-dropdown-item  icon="sc-icon-AbilityAuthorization" @click="table_empower(scope.row)" divided>功能授权</el-dropdown-item>
									<el-dropdown-item  icon="sc-icon-DataAuthorization">数据授权</el-dropdown-item>
									<el-dropdown-item  icon="sc-icon-UserList" @click="table_user_ist(scope.row)" divided>用户列表</el-dropdown-item>
									<el-dropdown-item @click="table_del(scope.row, 'delete')" icon="sc-icon-Delete">删除公司</el-dropdown-item>
								</el-dropdown-menu>
							</template>
						</el-dropdown>
					</template>
				</el-table-column>
			</scTable>
		</el-main>
	</el-container>

</template>

<script>

export default {
	name:"inventoryList",
	components: {

	},
	data() {
		return {
			size:'small',
			dialog: {
				save: false,
				show: false,
			},
			list: {
				apiObj: this.$API.orders.order.sock.list,
				column: [],
			},
			selection: [],
			exportShow:false,
			searchShow:false,
			searchList:[
				{name:'仓库编码',type:'text',code:['f_stock_id'],placeholder:"请输入仓库编码",isOpen:true,show:true},
				{name:'计划跟踪号',type:'text',code:['f_mto_no'],placeholder:"请输入计划跟踪号",isOpen:true,show:false},
				{name:'生产日期',type:'date',code:'f_produce_date',show:true},
				{name:'库存量(基本单位)',type:'text',code:['f_base_qty'],placeholder:"请输入库存量(基本单位)",isOpen:true,show:false},
				{name:'预留量(基本单位)',type:'text',code:['f_base_lock_qty'],placeholder:"请输入预留量(基本单位)",isOpen:true,show:false},
				{name:'库存量(库存辅单位)',type:'select',code:'f_sec_qty', data:[], placeholder:"请选择库存量(库存辅单位)",isOpen:true,show:false},
				{name:'预留量(辅单位)',type:'select',code:'f_sec_lock_qty', data:[], placeholder:"请选择预留量(辅单位)",isOpen:true,show:false},
				{name:'库存主单位编码',type:'text',code:['f_stock_unit_id'],placeholder:"请输入库存主单位编码",isOpen:true,show:false},
				{name:'编码',type:'text',code:['f_material_id'],placeholder:"请输入编码",isOpen:true,show:false},
				{name:'可用量(基本单位)',type:'text',code:['f_base_avb_qty'],placeholder:"请输入可用量(基本单位)",isOpen:true,show:false},
				{name:'实体主键',type:'text',code:['f_id'],placeholder:"请输入实体主键",isOpen:true,show:false},
				{name:'BOM版本编码',type:'text',code:['f_bom_id'],placeholder:"请输入BOM版本编码",isOpen:true,show:false},
				{name:'创建日期',type:'date',code:'created_at',show:true},
				{name:'关键字',type:'text',code:['name'],keyword:true,show:true},
			],
			params: {},
		}
	},
	methods: {
		searchShowClick(){
			this.searchShow = !this.searchShow;
			this.searchList.forEach(item=>{
				if(item.isOpen){
					item.show = this.searchShow
				}
			})
		},
		async getSelectData(item) {
			let {data, params} = item;
			this.params = params;
			let searchParams = this.$TOOL.objCopy(params);
			searchParams.field = ""
			if (typeof data.code === 'string') {
				searchParams.field = data.code;
			} else {
				searchParams.field = data.code[0];
			}
			if (data.type == 'select') {
				const res = await this.$API.orders.order.sock.field.post(searchParams);
				if (res.code == 200) {
					if (res.data && res.data.length > 0) {
						res.data.forEach(item => {
							item.label = item[data.code];
						})
					}
					this.searchList.forEach(item => {
						if (item.code == data.code) {
							item.data = res.data;
						}
					})
				}
			}
		},

		//添加
		add(){
			this.dialog.save = true;
			this.$nextTick(() => {
				this.$refs.saveDialog.open()
			})
		},

		// 批量导入
		importFile(){
			this.$nextTick(()=>{
				this.$refs.scImport.importFile();
			})
		},
		async importTemplate() {
			const res = await this.$API.orders.order.maintenance.template.post();
			const blob = new Blob([res]);
			const text = new Date().getTime();
			const eLink = document.createElement('a');
			eLink.download = "维保导入模版_"+text+'.xlsx';
			eLink.style.display = 'none';
			eLink.href = URL.createObjectURL(blob);
			document.body.appendChild(eLink);
			eLink.click();
			URL.revokeObjectURL(eLink.href);
			document.body.removeChild(eLink);
		},
		async importUpload(params) {
			const res = await this.$API.orders.order.maintenance.import.post(params);
			if(res.code == 200){
				this.$message.success('上传成功，开始导入数据');
			}
		},
		importSuccess(){
			this.$refs.table.refresh()
		},

		//编辑
		table_edit(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open('edit').setData(row)
			})
		},
		//查看
		table_show(row){
			this.dialog.show = true
			this.$nextTick(() => {
				this.$refs.showDialog.open('show').setData(row);
			})
		},
		//删除
		async table_del(row){
			this.$confirm(`确定删除 ${row.name} 吗？`, '提示', {
				type: 'warning'
			}).then(async () => {
				const reqData = {id: row.id};
				const res = await this.$API.system.company.delete.post(reqData);
				if(res.code == 200){
					this.$refs.table.refresh()
					this.$message.success("删除成功")
				}else{
					await this.$alert(res.message, "提示", {type: 'error'})
				}
			}).catch(()=>{})
		},
		// 功能授权
		table_empower(row){
			this.$router.push({
				path: '/setting/company/add-permission',
				query: {
					id: row.id,
					name:row.name
				}
			})
		},
		// 公司用户列表
		table_user_ist(row){
			this.$router.push({
				path: '/setting/user/company-user-list',
				query: {
					id: row.id,
					name:row.name
				}
			})
		},
		//表格选择后回调事件
		selectionChange(selection){
			this.selection = selection;
		},
		// 状态
		changeSwitch(val, row) {
			row.$switch_yx = true;
			setTimeout(async () => {
				let params = {
					id: row.id,
					status: row.active_status,
				};
				const res = await this.$API.system.company.status.post(params);
				if(res.code !=200){
					row.active_status = !row.active_status;
				}
				delete row.$switch_status;
				delete row.$switch_yx;
			}, 500);
		},
		// 下载导出
		exportChangeShow(params){
			if(params.type == 11){
				this.exportShow = params.status==0?true:false
			}
		},
		async exportData() {
			if(this.exportShow) return
			const res = await this.$API.orders.order.maintenance.export.post(this.params);
			if(res.code == 200){
				this.$message.success('开始导出');
			}
		},
		upSearch(){
			this.$refs.table.upData(this.params);
		},
		reset(){
			this.params = {};
			this.$refs.scSearch.reload();
			this.$refs.table.reload();
		},
		handleSaveSuccess(){
			this.$refs.table.refresh();
		},
	}
}
</script>

<style lang="scss" scoped>
.logoCell{
	display: flex;
	align-items: center;
	height: 20px;
	margin: 0 auto;
}
</style>
